#include <SBUS.h>
#include <Servo.h>

Servo myservo;
SBUS sbus(Serial2);
#define r1 2
#define r2 3
#define l1 4
#define l2 5
int x;//право лево
int y;//верх низ
int a;
int b;
int c;
int e;
int f;
int g; //ручки по буквам.  

//Все значения мапим от -255 до 255. выствляем 0 при -50<val<50 по римеру X
void setup()
{
  //myservo.attach(13);
  pinMode(13,OUTPUT);
  pinMode(11,OUTPUT);
  pinMode(12,OUTPUT);
  pinMode(26,OUTPUT);
  pinMode(8,OUTPUT);
  pinMode(35,OUTPUT);
  pinMode(48,OUTPUT);
  pinMode(5,OUTPUT);
  pinMode(4,OUTPUT);
  pinMode(2,OUTPUT);
  pinMode(3,OUTPUT); 
 digitalWrite(11,0);
 digitalWrite(12,0);
 digitalWrite(26,0);
 digitalWrite(8,0);
 digitalWrite(35,0);
 digitalWrite(48,0);
 digitalWrite(5,0);
 digitalWrite(4,0);
 digitalWrite(2,0);
 digitalWrite(3,0);
  sbus.begin();
  Serial.begin(9600);
  Serial.println("SBUS Status");
}

// this is timer2, which triggers ever 1ms and processes the incoming SBUS datastream
ISR(TIMER2_COMPA_vect)
{
  sbus.process();
}

void loop()
{
  
  
  delay(300);
  printSBUSStatus();
}

void printSBUSStatus()
{
//Serial.print("x");
//Serial.print("=");
  x=sbus.getNormalizedChannel(1);
  x=map(x,-70,70,-255,255);
  if((x>-50)&&(x<50)){
    x=0; 
  }
  if(x>240){
    x=255;
  }
  if(x<-240){
    x=-255;
  }
//Serial.print(x);
//Serial.print("  ");
 //Serial.print("y=");
  y=sbus.getNormalizedChannel(2);
  y=map(y,70,-70,-255,255);
  if((y>-50)&&(y<50)){
    y=0; 
  }
  if(y>240){
    y=255;
  }
   if(y<-240){
    y=-255;
  }
    //Serial.print(y);
     //Serial.print("  ");
     //Serial.print("c=");
     c=sbus.getNormalizedChannel(5);
  c=map(c,-93,94,-255,255);
  if((c>-5)&&(c<5)){
    c=0; 
  }
   //Serial.print(c);
  // Serial.print(" ");
//   Serial.print("g=");

  g=sbus.getNormalizedChannel(10);
  g=map(g,-91,95,-255,255);
  if((g>-50)&&(g<50)){
    g=0; 
  }
   //Serial.print(g);
     // Serial.print(" ");
   //Serial.print("e=");
  e=sbus.getNormalizedChannel(8);
  e=map(e,-93,94,-255,255);
  if((e>-50)&&(e<50)){
    e=0; 
  }
  //Serial.print(e);
    // Serial.print(" ");
 Serial.print("a=");
  a=sbus.getNormalizedChannel(7);
  a=map(a,-93,94,0,180);
  //if((a>-5)&&(a<5)){
    //a=0; 
  
  Serial.print(a);

  Serial.print("Ch3  ");
  Serial.print(sbus.getNormalizedChannel(3));
   Serial.print("  ");
  Serial.print("Ch4  ");
  Serial.print(sbus.getNormalizedChannel(4));
   Serial.print("  ");
 Serial.print("Ch6  ");
  Serial.print(sbus.getNormalizedChannel(6));

  Serial.print("Ch9  ");
  Serial.print(sbus.getNormalizedChannel(9));

  Serial.print("Ch11 ");
  Serial.print(sbus.getNormalizedChannel(11));
   Serial.print("  ");
  Serial.print("Ch12 ");
  Serial.print(sbus.getNormalizedChannel(12));
   Serial.print("  ");
  Serial.print("Ch13 ");
  Serial.print(sbus.getNormalizedChannel(13));
   Serial.print("  ");
  Serial.print("Ch14 ");
  Serial.print(sbus.getNormalizedChannel(14));
  Serial.print("Ch15 ");
  Serial.print(sbus.getNormalizedChannel(15));
   Serial.print("  ");
  Serial.print("Ch16 ");
  Serial.print(sbus.getNormalizedChannel(16));
  Serial.println();
  
  //Движение моторов настройка
int M1=x+y;
 int M2=x-y;
 if(M1>255){
      M1=255;
    }
    if(M1<-255){
      M1=-255;
    }
     if(M2>255){
      M2=255;
    }
    if(M2<-255){
      M2=-255;
    }
//Serial.print(M1);
//Serial.print("_____");
//Serial.println(M2);
if(M2>0){
  digitalWrite(l2,0);
  analogWrite(l1,M2);
}
else{
   digitalWrite(l1,0);
  analogWrite(l2,- M2);
}

if(M1>0){
  digitalWrite(r2,0);
  analogWrite(r1,M1);
}
else{
   digitalWrite(r1,0);
  analogWrite(r2,- M1);
}
//Движение моторов настройка завершена
if(e==0){
  digitalWrite(26,0);
  digitalWrite(8,0);
}
if(e>50){
  digitalWrite(26,0);
  digitalWrite(8,1);
}
 if(e<-50){
  digitalWrite(8,0);
  digitalWrite(26,1);
  
 }
 if(g==0){
digitalWrite(35,0);
digitalWrite(48,0);
  
 }
  if(g>50){
digitalWrite(35,0);



digitalWrite(48,1);
  
 }
 if(g<-50){
digitalWrite(48,0);
digitalWrite(35,1);
  
 }
 
 if(c==0){
digitalWrite(11,0);
digitalWrite(12,0);
  
 }
  if(c>50){
digitalWrite(11,0);
digitalWrite(12,1);
  
 }
 if(c<-50){
digitalWrite(12,0);
digitalWrite(11,1);
  
 }
 //myservo.write(a);
 if(a>150){
  digitalWrite(13,1);
 }
 if(a<40){
  digitalWrite(13,0);
 }
 }


 





